; numeric equality : use =

(= 1 1.0)      ; #t
(= .5 (/ 1 2)) ; #t
(eq? 1 1.0)    ; #f
(eq? 1. 1.)    ; #f, actually this is unspecified and may be either #t or #f
(newline)

; symbol equality : use eqv? (or eq?)
; eq? is a pointer comparison
; eqv? is slightly more general equivalence that may or may not 
; merge representions of equivalent objects depending on the
; implementation.  
; Although eqv? recognizes numbers with the same value, it does
; not promote integers to reals.

(eqv? 'a 'a)    ; #t
(eq? 'a 'a)     ; #t
(eqv? 1.0 1.0)  ; #t
(eqv? 1.0 1.0)  ; #t
(eq? 1.0 1.0)   ; #f
(eq? 1.0 1)     ; #f
(newline)

; list equality : use equal?
; equal? applies eqv? recursively

(define sa (list 'a 'b))
(define sb (list 'a 'b))

(equal? sa sb)  ; #t
(eq? sa sb)     ; #f
