; Manipulate expressions stored as lists in prefix order.
; Note that this code expects the operators
; to be symbols that can be evaluated to functions,
; not the actual functions

(define (make-exp op left right)
  (list op left right))

(define (operator exp)
  (car exp))

(define (left exp)
  (cadr exp))

(define (right exp)
  (caddr exp))

(define (eval-op op)
  (cond
    ((eqv? op '^) expt)
    (else (eval op))))

(define (eval-expr exp)
  (if (not (list? exp))
      exp
      ((eval-op (operator exp))
       (eval-expr (left exp))
       (eval-expr (right exp)))))
