(define (make-exp op left right)
  (list op left right))

(define (operator exp)
  (car exp))

(define (left exp)
  (cadr exp))

(define (right exp)
  (caddr exp))

(define (post-order exp)
  (if (not (pair? exp))
      (list exp)
      (append 
       (post-order (left exp))
       (post-order (right exp))
       (list (operator exp)))))

; define the expression tree structures using lists

(define a '(+ 1 2))                     ; 1+2=3
(define b (make-exp '* a 3))            ; (1+2)*3 = 9
(define c (make-exp '/ a (make-exp '+ 3 4)))  ; (1+2)/(3+4) = 3/7
(define d (make-exp '* c (make-exp '/ 1 c)))  ; c * (1/c) = 1
(define e '(+ 1 (* 2 3)))               ; (1+(2*3)) = 7
(define f '(+ 1 (* 2 (- 3 5))))         ; (1+(2*(3-5))) = -3

; display in postfix notation

(post-order a)
(post-order b)
(post-order c)
(post-order d)
(post-order e)
(post-order f)
